// Code generated by mockery v2.33.3. DO NOT EDIT.

package mocks

import (
	context "context"

	mock "github.com/stretchr/testify/mock"
	providers "gitlab.com/cyverse/cacao-common/service/providers"

	service "gitlab.com/cyverse/cacao-common/service"
)

// MockProviderOpenStackSvcClient is an autogenerated mock type for the MockProviderOpenStackSvcClient type
type MockProviderOpenStackSvcClient struct {
	mock.Mock
}

// ApplicationCredentialList provides a mock function with given fields: ctx, actor, credOpt
func (_m *MockProviderOpenStackSvcClient) ApplicationCredentialList(ctx context.Context, actor service.Actor, credOpt providers.CredentialOption) ([]providers.ApplicationCredential, error) {
	ret := _m.Called(ctx, actor, credOpt)

	var r0 []providers.ApplicationCredential
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, service.Actor, providers.CredentialOption) ([]providers.ApplicationCredential, error)); ok {
		return rf(ctx, actor, credOpt)
	}
	if rf, ok := ret.Get(0).(func(context.Context, service.Actor, providers.CredentialOption) []providers.ApplicationCredential); ok {
		r0 = rf(ctx, actor, credOpt)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]providers.ApplicationCredential)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, service.Actor, providers.CredentialOption) error); ok {
		r1 = rf(ctx, actor, credOpt)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// AuthenticationTest provides a mock function with given fields: ctx, actor, variables
func (_m *MockProviderOpenStackSvcClient) AuthenticationTest(ctx context.Context, actor service.Actor, variables map[string]string) error {
	ret := _m.Called(ctx, actor, variables)

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, service.Actor, map[string]string) error); ok {
		r0 = rf(ctx, actor, variables)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// CreateApplicationCredential provides a mock function with given fields: ctx, actor, scope, name, credOpt
func (_m *MockProviderOpenStackSvcClient) CreateApplicationCredential(ctx context.Context, actor service.Actor, scope providers.ProjectScope, name string, credOpt providers.CredentialOption) (string, error) {
	ret := _m.Called(ctx, actor, scope, name, credOpt)

	var r0 string
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, service.Actor, providers.ProjectScope, string, providers.CredentialOption) (string, error)); ok {
		return rf(ctx, actor, scope, name, credOpt)
	}
	if rf, ok := ret.Get(0).(func(context.Context, service.Actor, providers.ProjectScope, string, providers.CredentialOption) string); ok {
		r0 = rf(ctx, actor, scope, name, credOpt)
	} else {
		r0 = ret.Get(0).(string)
	}

	if rf, ok := ret.Get(1).(func(context.Context, service.Actor, providers.ProjectScope, string, providers.CredentialOption) error); ok {
		r1 = rf(ctx, actor, scope, name, credOpt)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// CredentialList provides a mock function with given fields: ctx, actor, projectID, projectName
func (_m *MockProviderOpenStackSvcClient) CredentialList(ctx context.Context, actor service.Actor, projectID string, projectName string) ([]service.CredentialModel, error) {
	ret := _m.Called(ctx, actor, projectID, projectName)

	var r0 []service.CredentialModel
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, service.Actor, string, string) ([]service.CredentialModel, error)); ok {
		return rf(ctx, actor, projectID, projectName)
	}
	if rf, ok := ret.Get(0).(func(context.Context, service.Actor, string, string) []service.CredentialModel); ok {
		r0 = rf(ctx, actor, projectID, projectName)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]service.CredentialModel)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, service.Actor, string, string) error); ok {
		r1 = rf(ctx, actor, projectID, projectName)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeleteApplicationCredential provides a mock function with given fields: ctx, actor, credentialID
func (_m *MockProviderOpenStackSvcClient) DeleteApplicationCredential(ctx context.Context, actor service.Actor, credentialID string) error {
	ret := _m.Called(ctx, actor, credentialID)

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, service.Actor, string) error); ok {
		r0 = rf(ctx, actor, credentialID)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// FlavorList provides a mock function with given fields: ctx, actor, region, credOpt
func (_m *MockProviderOpenStackSvcClient) FlavorList(ctx context.Context, actor service.Actor, region string, credOpt providers.CredentialOption) ([]providers.Flavor, error) {
	ret := _m.Called(ctx, actor, region, credOpt)

	var r0 []providers.Flavor
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, service.Actor, string, providers.CredentialOption) ([]providers.Flavor, error)); ok {
		return rf(ctx, actor, region, credOpt)
	}
	if rf, ok := ret.Get(0).(func(context.Context, service.Actor, string, providers.CredentialOption) []providers.Flavor); ok {
		r0 = rf(ctx, actor, region, credOpt)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]providers.Flavor)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, service.Actor, string, providers.CredentialOption) error); ok {
		r1 = rf(ctx, actor, region, credOpt)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetApplicationCredential provides a mock function with given fields: ctx, actor, applicationCredentialID, credOpt
func (_m *MockProviderOpenStackSvcClient) GetApplicationCredential(ctx context.Context, actor service.Actor, applicationCredentialID string, credOpt providers.CredentialOption) (*providers.ApplicationCredential, error) {
	ret := _m.Called(ctx, actor, applicationCredentialID, credOpt)

	var r0 *providers.ApplicationCredential
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, service.Actor, string, providers.CredentialOption) (*providers.ApplicationCredential, error)); ok {
		return rf(ctx, actor, applicationCredentialID, credOpt)
	}
	if rf, ok := ret.Get(0).(func(context.Context, service.Actor, string, providers.CredentialOption) *providers.ApplicationCredential); ok {
		r0 = rf(ctx, actor, applicationCredentialID, credOpt)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*providers.ApplicationCredential)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, service.Actor, string, providers.CredentialOption) error); ok {
		r1 = rf(ctx, actor, applicationCredentialID, credOpt)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetFlavor provides a mock function with given fields: ctx, actor, region, flavorID, credOpt
func (_m *MockProviderOpenStackSvcClient) GetFlavor(ctx context.Context, actor service.Actor, region string, flavorID string, credOpt providers.CredentialOption) (*providers.Flavor, error) {
	ret := _m.Called(ctx, actor, region, flavorID, credOpt)

	var r0 *providers.Flavor
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, service.Actor, string, string, providers.CredentialOption) (*providers.Flavor, error)); ok {
		return rf(ctx, actor, region, flavorID, credOpt)
	}
	if rf, ok := ret.Get(0).(func(context.Context, service.Actor, string, string, providers.CredentialOption) *providers.Flavor); ok {
		r0 = rf(ctx, actor, region, flavorID, credOpt)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*providers.Flavor)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, service.Actor, string, string, providers.CredentialOption) error); ok {
		r1 = rf(ctx, actor, region, flavorID, credOpt)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetImage provides a mock function with given fields: ctx, actor, region, imageID, credOpt
func (_m *MockProviderOpenStackSvcClient) GetImage(ctx context.Context, actor service.Actor, region string, imageID string, credOpt providers.CredentialOption) (*providers.OpenStackImage, error) {
	ret := _m.Called(ctx, actor, region, imageID, credOpt)

	var r0 *providers.OpenStackImage
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, service.Actor, string, string, providers.CredentialOption) (*providers.OpenStackImage, error)); ok {
		return rf(ctx, actor, region, imageID, credOpt)
	}
	if rf, ok := ret.Get(0).(func(context.Context, service.Actor, string, string, providers.CredentialOption) *providers.OpenStackImage); ok {
		r0 = rf(ctx, actor, region, imageID, credOpt)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*providers.OpenStackImage)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, service.Actor, string, string, providers.CredentialOption) error); ok {
		r1 = rf(ctx, actor, region, imageID, credOpt)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetProject provides a mock function with given fields: ctx, actor, projectID, credOpt
func (_m *MockProviderOpenStackSvcClient) GetProject(ctx context.Context, actor service.Actor, projectID string, credOpt providers.CredentialOption) (*providers.Project, error) {
	ret := _m.Called(ctx, actor, projectID, credOpt)

	var r0 *providers.Project
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, service.Actor, string, providers.CredentialOption) (*providers.Project, error)); ok {
		return rf(ctx, actor, projectID, credOpt)
	}
	if rf, ok := ret.Get(0).(func(context.Context, service.Actor, string, providers.CredentialOption) *providers.Project); ok {
		r0 = rf(ctx, actor, projectID, credOpt)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*providers.Project)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, service.Actor, string, providers.CredentialOption) error); ok {
		r1 = rf(ctx, actor, projectID, credOpt)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetToken provides a mock function with given fields: ctx, actor, credOpt
func (_m *MockProviderOpenStackSvcClient) GetToken(ctx context.Context, actor service.Actor, credOpt providers.CredentialOption) (*providers.Token, error) {
	ret := _m.Called(ctx, actor, credOpt)

	var r0 *providers.Token
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, service.Actor, providers.CredentialOption) (*providers.Token, error)); ok {
		return rf(ctx, actor, credOpt)
	}
	if rf, ok := ret.Get(0).(func(context.Context, service.Actor, providers.CredentialOption) *providers.Token); ok {
		r0 = rf(ctx, actor, credOpt)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*providers.Token)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, service.Actor, providers.CredentialOption) error); ok {
		r1 = rf(ctx, actor, credOpt)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// ImageList provides a mock function with given fields: ctx, actor, region, credOpt
func (_m *MockProviderOpenStackSvcClient) ImageList(ctx context.Context, actor service.Actor, region string, credOpt providers.CredentialOption) ([]providers.OpenStackImage, error) {
	ret := _m.Called(ctx, actor, region, credOpt)

	var r0 []providers.OpenStackImage
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, service.Actor, string, providers.CredentialOption) ([]providers.OpenStackImage, error)); ok {
		return rf(ctx, actor, region, credOpt)
	}
	if rf, ok := ret.Get(0).(func(context.Context, service.Actor, string, providers.CredentialOption) []providers.OpenStackImage); ok {
		r0 = rf(ctx, actor, region, credOpt)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]providers.OpenStackImage)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, service.Actor, string, providers.CredentialOption) error); ok {
		r1 = rf(ctx, actor, region, credOpt)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// ListAllRecordset provides a mock function with given fields: ctx, actor, credOpt
func (_m *MockProviderOpenStackSvcClient) ListAllRecordset(ctx context.Context, actor service.Actor, credOpt providers.CredentialOption) ([]providers.DNSRecordset, error) {
	ret := _m.Called(ctx, actor, credOpt)

	var r0 []providers.DNSRecordset
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, service.Actor, providers.CredentialOption) ([]providers.DNSRecordset, error)); ok {
		return rf(ctx, actor, credOpt)
	}
	if rf, ok := ret.Get(0).(func(context.Context, service.Actor, providers.CredentialOption) []providers.DNSRecordset); ok {
		r0 = rf(ctx, actor, credOpt)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]providers.DNSRecordset)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, service.Actor, providers.CredentialOption) error); ok {
		r1 = rf(ctx, actor, credOpt)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// ListCatalog provides a mock function with given fields: ctx, actor, credOpt
func (_m *MockProviderOpenStackSvcClient) ListCatalog(ctx context.Context, actor service.Actor, credOpt providers.CredentialOption) ([]providers.CatalogEntry, error) {
	ret := _m.Called(ctx, actor, credOpt)

	var r0 []providers.CatalogEntry
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, service.Actor, providers.CredentialOption) ([]providers.CatalogEntry, error)); ok {
		return rf(ctx, actor, credOpt)
	}
	if rf, ok := ret.Get(0).(func(context.Context, service.Actor, providers.CredentialOption) []providers.CatalogEntry); ok {
		r0 = rf(ctx, actor, credOpt)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]providers.CatalogEntry)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, service.Actor, providers.CredentialOption) error); ok {
		r1 = rf(ctx, actor, credOpt)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// ListRecordset provides a mock function with given fields: ctx, actor, credOpt, zoneID
func (_m *MockProviderOpenStackSvcClient) ListRecordset(ctx context.Context, actor service.Actor, credOpt providers.CredentialOption, zoneID string) ([]providers.DNSRecordset, error) {
	ret := _m.Called(ctx, actor, credOpt, zoneID)

	var r0 []providers.DNSRecordset
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, service.Actor, providers.CredentialOption, string) ([]providers.DNSRecordset, error)); ok {
		return rf(ctx, actor, credOpt, zoneID)
	}
	if rf, ok := ret.Get(0).(func(context.Context, service.Actor, providers.CredentialOption, string) []providers.DNSRecordset); ok {
		r0 = rf(ctx, actor, credOpt, zoneID)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]providers.DNSRecordset)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, service.Actor, providers.CredentialOption, string) error); ok {
		r1 = rf(ctx, actor, credOpt, zoneID)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// ListZone provides a mock function with given fields: ctx, actor, credOpt
func (_m *MockProviderOpenStackSvcClient) ListZone(ctx context.Context, actor service.Actor, credOpt providers.CredentialOption) ([]providers.DNSZone, error) {
	ret := _m.Called(ctx, actor, credOpt)

	var r0 []providers.DNSZone
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, service.Actor, providers.CredentialOption) ([]providers.DNSZone, error)); ok {
		return rf(ctx, actor, credOpt)
	}
	if rf, ok := ret.Get(0).(func(context.Context, service.Actor, providers.CredentialOption) []providers.DNSZone); ok {
		r0 = rf(ctx, actor, credOpt)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]providers.DNSZone)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, service.Actor, providers.CredentialOption) error); ok {
		r1 = rf(ctx, actor, credOpt)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// ProjectList provides a mock function with given fields: ctx, actor, credOpt
func (_m *MockProviderOpenStackSvcClient) ProjectList(ctx context.Context, actor service.Actor, credOpt providers.CredentialOption) ([]providers.Project, error) {
	ret := _m.Called(ctx, actor, credOpt)

	var r0 []providers.Project
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, service.Actor, providers.CredentialOption) ([]providers.Project, error)); ok {
		return rf(ctx, actor, credOpt)
	}
	if rf, ok := ret.Get(0).(func(context.Context, service.Actor, providers.CredentialOption) []providers.Project); ok {
		r0 = rf(ctx, actor, credOpt)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]providers.Project)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, service.Actor, providers.CredentialOption) error); ok {
		r1 = rf(ctx, actor, credOpt)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// RegionList provides a mock function with given fields: ctx, actor, credOpt
func (_m *MockProviderOpenStackSvcClient) RegionList(ctx context.Context, actor service.Actor, credOpt providers.CredentialOption) ([]providers.Region, error) {
	ret := _m.Called(ctx, actor, credOpt)

	var r0 []providers.Region
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, service.Actor, providers.CredentialOption) ([]providers.Region, error)); ok {
		return rf(ctx, actor, credOpt)
	}
	if rf, ok := ret.Get(0).(func(context.Context, service.Actor, providers.CredentialOption) []providers.Region); ok {
		r0 = rf(ctx, actor, credOpt)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]providers.Region)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, service.Actor, providers.CredentialOption) error); ok {
		r1 = rf(ctx, actor, credOpt)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// NewMockProviderOpenStackSvcClient creates a new instance of MockProviderOpenStackSvcClient. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockProviderOpenStackSvcClient(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockProviderOpenStackSvcClient {
	mock := &MockProviderOpenStackSvcClient{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
